/**
 *
 * Kicsit bonyolultabb plda a gtest keretrendszer hasznlatra.
 *
 * --gtest_output=xml indtsi argumentummal indtva az 
 * eredmny xml fjlba is rdik
 * 
 */
#include <gtest/gtest.h>
#include <vector>

class VektorTeszt : public ::testing::Test {
// Mindennek protected-nek kell lenni!
protected:
    std::vector<int>  v1, v2;

    // Ide kell tenni minden olyat, ami a tezsteset krnyzett lltja el
    void SetUp() {
        std::cout << "Teszteset indul" << std::endl;        // ez a kirs csak demo
        v1.push_back(1);        
        v1.push_back(2);
        v2 = v1;
    }

    // Ez lebontja a krnyezetet. A destruktor eltt hvdik
    void TearDown() {
        std::cout << "Teszteset vege" << std::endl;         // ez a kirs csak demo
    }

    ~VektorTeszt() {
        std::cout << "Itt a legvege" << std::endl;          // ez a kirs csak demo
    }
};

// Teszteljuk a mretet
TEST_F(VektorTeszt, MeretVizsgalata) {
    ASSERT_EQ((int)v1.size(), (int)v2.size()) << "A mret is szmt!";
} 

// Teszteljk a tartalmat
TEST_F(VektorTeszt, ElemekVizsgalata) {
    // Meg kell nzni a mretet, mert a tesztek fggetelnl futnak
    ASSERT_EQ((int)v1.size(), (int)v2.size()) << "A mret is szmt!";
    // Nzzk a tartalmat
    for (unsigned int i = 0; i < v1.size(); i++)
        EXPECT_EQ(v1[i], v2[i]);
}

// Ez csak kir valamit az XML-be
TEST_F(VektorTeszt, Meret) {
    RecordProperty("Meret1", (int)v1.size());
    RecordProperty("Meret2", (int)v2.size());
}
